﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

        //Create a SessionStorage at the server to persist the DataTable changes
        if (Session["data"] == null)
        {
            Session["data"] = MakeTable();
        }

        this.WebDataGrid1.DataSource = (DataTable)Session["data"];
    }

    private DataTable MakeTable()
    {
        // Create a new DataTable.
        System.Data.DataTable table = new DataTable("Table");
        // Declare variables for DataColumn and DataRow objects.
        DataColumn column;
        DataRow row;

        // Create new DataColumn, set DataType, 
        // ColumnName and add to DataTable.    
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "id";
        column.ReadOnly = true;
        // Add the Column to the DataColumnCollection.
        table.Columns.Add(column);

        // Create second column.
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Item";
        column.AutoIncrement = false;
        column.Caption = "Item";
        column.ReadOnly = false;
        column.Unique = false;
        // Add the column to the table. 
        table.Columns.Add(column);

        // Create third column.
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Data";
        column.AutoIncrement = false;
        column.Caption = "Data";
        column.ReadOnly = false;
        column.Unique = false;
        // Add the column to the table.
        table.Columns.Add(column);

        // Make the ID PrimaryKeyColumns collection and add 1 primary key column. Primary key is a requiered for using CRUD operations
        DataColumn[] PrimaryKeyColumns = new DataColumn[1];
        PrimaryKeyColumns[0] = table.Columns["id"];
        table.PrimaryKey = PrimaryKeyColumns;

        for (int i = 0; i <= 20; i++)
        {
            row = table.NewRow();
            row["id"] = i;
            row["Item"] = "Item " + i;
            row["Data"] = "Data " + i;
            table.Rows.Add(row);
        }
        return table;
    }

    protected void WebDataGrid1_RowUpdating(object sender, Infragistics.Web.UI.GridControls.RowUpdatingEventArgs e)
    {
        DataTable table = (DataTable)Session["data"];

        var row = table.Rows.Find(e.Row.DataKey);

        row["Item"] = e.Values["Item"];
        row["Data"] = e.Values["Data"];
        table.AcceptChanges();

        Session["data"] = table;

        this.WebDataGrid1.DataSource = table;
        this.WebDataGrid1.DataBind();
    }


    protected void WebDataGrid1_RowAdding(object sender, Infragistics.Web.UI.GridControls.RowAddingEventArgs e)
    {
        DataTable table = (DataTable)Session["data"];

        var row = table.NewRow();

        row["Item"] = e.Values["Item"];
        row["Data"] = e.Values["Data"];
        row["ID"] = WebDataGrid1.Rows.Count;
 

        table.Rows.Add(row);
        Session["data"] = table;
        this.WebDataGrid1.DataSource = table;
        this.WebDataGrid1.DataBind();
    }

    //For full functionality Row.DataKey should be modified, this is only a code sample and Row.DataKey duplication  
    //(in case of RowDeleting followed by RowAdding) is not handled
    protected void WebDataGrid1_RowsDeleting(object sender, Infragistics.Web.UI.GridControls.RowDeletingEventArgs e)
    {
        
        var rowToDelete = e.Row.DataKey;
        DataTable table = (DataTable)Session["data"];
        table.Rows.Find(rowToDelete).Delete();
        table.AcceptChanges();

        Session["data"] = table;

        this.WebDataGrid1.DataSource = table;
        this.WebDataGrid1.DataBind();
    }
}